<!DOCTYPE html>
<html>
<head>
  <title>Signature</title>
  <link rel="shortcut icon" href="https://www.engineered.co.in/static/icons/favicon.ico" />
  <link href="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.css" rel="stylesheet">
  <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
  <!-- <script src="./res/icons.js"></script> -->
  <script src="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.js"></script>
</head>
<body class="mdc-typography" style="margin: 0px; --mdc-theme-primary:#005BA1;">
  <header class="mdc-top-app-bar ">
    <div class="mdc-top-app-bar__row">
      <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-start">
        <img class="material-icons mdc-top-app-bar__navigation-icon mdc-icon-button" aria-label="Favorite" src="https://www.engineered.co.in/static/images/logo.svg" style="width: 72px; height: auto;" onclick="window.open('https://www.engineered.co.in', '_blank')">
        <span class="mdc-top-app-bar__title">Signature Generator</span>
      </section>
      <section class="mdc-top-app-bar__section mdc-top-app-bar__section--align-end" role="toolbar">
        <button class="material-icons mdc-top-app-bar__action-item mdc-icon-button" aria-label="Source" title="View Source (Alt+S)" onclick="window.open('https://gitlab.com/engineered-in/general/signature#signature-generator', '_blank');" id="source-id">source</button>
        <button class="material-icons mdc-top-app-bar__action-item mdc-icon-button" aria-label="Article" title="How this works? (Alt+H)" id="help-id" onclick="window.open('https://www.linkedin.com/pulse/deep-link-your-email-signature-swarup-selvaraj/','_blank')">live_help</button>
      </section>
    </div>
  </header>
  <main class="mdc-top-app-bar--fixed-adjust" >
    <div class="mdc-layout-grid" style="padding: 20px;">
      <div class="mdc-layout-grid__inner">
        <div class="mdc-layout-grid__cell">
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="name-label-id">Your Full Name</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="name-label-id" id="name-id" pattern=".{8,}" onchange="updateSignature();">
          </label><br><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="role-label-id">Your Role</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="role-label-id" id="role-id" pattern=".{8,}" onchange="updateSignature();">
          </label><br><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="email-label-id">Your Email Address</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="email-label-id" id="email-id" pattern="[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,}$" onchange="updateSignature();">
          </label><br><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="phone-label-id">Your Phone Number</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <span class="mdc-text-field__affix mdc-text-field__affix--prefix">+</span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="phone-label-id" aria-controls="phone-helper-id"
             aria-describedby="phone-helper-id" id="phone-id" pattern="[0-9]{8,15}" maxlength="15" onchange="updateSignature();">
          </label>
          <div class="mdc-text-field-helper-line">
            <div class="mdc-text-field-helper-text" id="phone-helper-id" aria-hidden="true">Include Country Code</div>
          </div><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="site-label-id">Your Website</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="site-label-id" id="site-id" pattern="https?://.+" onchange="updateSignature();">
          </label>
          <div class="mdc-text-field-helper-line">
            <div class="mdc-text-field-helper-text" id="phone-helper-id" aria-hidden="true">Include http</div>
          </div><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="linkedin-label-id">Your LinkedIn Profile Name</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="linkedin-label-id" id="linkedin-id" pattern=".{4,}" onchange="updateBadge(this);">
          </label><br><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="location-label-id">Your Location</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="location-label-id" id="location-id" pattern=".{8,}" onchange="updateSignature();">
          </label><br><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="gitlab-label-id">Your GitLab Profile Name</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="gitlab-label-id" id="gitlab-id" pattern=".{4,}" onchange="updateSignature();">
          </label><br><br>
          <label class="mdc-text-field mdc-text-field--outlined">
            <span class="mdc-notched-outline">
              <span class="mdc-notched-outline__leading"></span>
              <span class="mdc-notched-outline__notch">
                <span class="mdc-floating-label" id="github-label-id">Your GitHub Profile Name</span>
              </span>
              <span class="mdc-notched-outline__trailing"></span>
            </span>
            <input type="text" class="mdc-text-field__input" aria-labelledby="github-label-id" id="github-id" pattern=".{8,}" onchange="updateSignature();">
          </label><br><br>
        </div>
        <div class="mdc-layout-grid__cell">
          <div style="display: none;">
            <label for="embed">Embed Icons</label>
            <div class="mdc-switch">
              <div class="mdc-switch__track"></div>
              <div class="mdc-switch__thumb-underlay">
                <div class="mdc-switch__thumb"></div>
                <input type="checkbox" id="embed" class="mdc-switch__native-control" role="switch" aria-checked="true" checked onchange="updateSignature">
              </div>
            </div> <br><br>
            <label class="mdc-text-field mdc-text-field--outlined">
              <span class="mdc-notched-outline">
                <span class="mdc-notched-outline__leading"></span>
                <span class="mdc-notched-outline__notch">
                  <span class="mdc-floating-label" id="size-label-id">Icon Size (pixels)</span>
                </span>
                <span class="mdc-notched-outline__trailing"></span>
              </span>
              <input type="number" class="mdc-text-field__input" aria-labelledby="size-label-id" id="size-id" pattern=".{4,}" onchange="updateSize(this);" value="16" min="8" max="128" step="4">
              <span class="mdc-text-field__affix mdc-text-field__affix--suffix">px</span>
            </label> &nbsp; &nbsp;
          </div>
          <div class="copy">
            <div class="mdc-touch-target-wrapper">
              <button class="mdc-fab mdc-fab--touch" title="Copy Signature to Clipboard! (Alt+C)" style="background-color: var(--mdc-theme-primary);" onclick="copySignature();" id="signature-button-id">
                <div class="mdc-fab__ripple"></div>
                <span class="material-icons mdc-fab__icon">content_paste</span>
                <div class="mdc-fab__touch"></div>
              </button>
            </div>
            <div id="signature"></div>
          </div><br><br>
          <div id="in-badge"></div>
        </div>
      </div>
    </div>
  </main>
  <script type="text/javascript">
    Array.from(document.querySelectorAll('.mdc-text-field')).map(function(v){mdc.textField.MDCTextField.attachTo(v);});
    Array.from(document.querySelectorAll('.mdc-switch')).map(function(v){mdc.switchControl.MDCSwitch.attachTo(v);});
    document.body.style.setProperty('--icon-size','16px');
    document.body.style.setProperty('--mdc-theme-primary','#005BA1');
    document.body.style.setProperty('--mdc-theme--on-surface','#005BA1');
    // https://stackoverflow.com/questions/28450471/convert-inline-svg-to-base64-string
    // https://levelup.gitconnected.com/draw-an-svg-to-canvas-and-download-it-as-image-in-javascript-f7f7713cf81f
    function copySignature()
    { // Copies signature block to Clipboard
      var el = document.getElementById('signature');
      var selection = window.getSelection();
      var range = document.createRange();
      range.selectNode(el);
      selection.removeAllRanges(); // clear current selection
      selection.addRange(range); // to select text
      document.execCommand("copy");
      selection.removeAllRanges();// to deselect
      alert('Your Signature has been copied to Clipboard!\n' +
        '-----------------------------------------------\n' +
        'Useful Shortcuts:\n\n' +
        'Alt + H ==> How this Works?\n\n' +
        'Alt + S ==> View Source Repository\n\n' +
        'Alt + C ==> Copy Signature\n\n' +
        '-----------------------------------------------\n' +
        'Disclaimer:\n\n' +
        'This is a static HTML page (generated in your personal device).\n' +
        'Your personal information is NOT visible to the server ¯\\_(ツ)_/¯'
        );
    }
    function updateSize(el)
    { // Updates the size of icons and font.
      if(el.checkValidity() && el.value.length>0)
      {
        document.body.style.setProperty('--icon-size', el.value + 'px');
      }
    }
    function updateSignature()
    { // Generates and Renders Signature block upon input change.
      var target = document.getElementById("signature");
      var name = document.getElementById("name-id");
      var role = document.getElementById("role-id");
      var email = document.getElementById("email-id");
      var phone = document.getElementById("phone-id");
      var site = document.getElementById("site-id");
      var linkedin = document.getElementById("linkedin-id");
      var location = document.getElementById("location-id");
      var gitlab = document.getElementById("gitlab-id");
      var github = document.getElementById("github-id");
      var paragraph = document.createElement("p");
      var checked = document.getElementById('embed').checked;
      var source = '';
      target.innerHTML = '';
      if(name.checkValidity() && name.value.length>0)
      {
        paragraph.innerHTML += '<span class="signature-header">' + name.value + '</span><br>';
      }
      if(role.checkValidity() && role.value.length>0)
      {
        paragraph.innerHTML += '<span class="signature-sub-header">' + role.value + '</span><br>';
      }
      if(site.checkValidity() && site.value.length>0)
      {
        //source = checked ? home_svg : './res/home.svg';
        source = checked ? './res/home.png' : './res/home.svg';
        paragraph.innerHTML += '<span class="icon"><a href="'+ site.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      if(email.checkValidity() && email.value.length>0)
      {
        if(email.value.toLowerCase().indexOf('gmail')>0)
        {
          //source = checked ? gmail_svg : './res/gmail.svg';
          source = checked ? './res/gmail.png' : './res/gmail.svg';
          paragraph.innerHTML += '<span class="icon"><a href="mailto:'+ email.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
        }
        else
        {
          //source = checked ? outlook_svg : './res/outlook.svg';
          source = checked ? './res/outlook.png' : './res/outlook.svg';
          paragraph.innerHTML += '<span class="icon"><a href="mailto:'+ email.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
        }
      }
      if(phone.checkValidity() && phone.value.length>0)
      {
        //source = checked ? phone_svg : './res/phone.svg';
        source = checked ? './res/phone.png' : './res/phone.svg';
        paragraph.innerHTML += '<span class="icon"><a href="tel:+' + phone.value + '" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      if(email.checkValidity() && email.value.length>0)
      {
        //source = checked ? teams_svg : './res/teams.svg';
        source = checked ? './res/teams.png' : './res/teams.svg';
        paragraph.innerHTML += '<span class="icon"><a href="https://teams.microsoft.com/l/chat/0/0?users='+ email.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      if(linkedin.checkValidity() && linkedin.value.length>0)
      {
        //source = checked ? linkedin_svg : './res/linkedin.svg';
        source = checked ? './res/linkedin.png' : './res/linkedin.svg';
        paragraph.innerHTML += '<span class="icon"><a href="https://www.linkedin.com/in/'+ linkedin.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      if(gitlab.checkValidity() && gitlab.value.length>0)
      {
        //source = checked ? gitlab_svg : './res/gitlab.svg';
        source = checked ? './res/gitlab.png' : './res/gitlab.svg';
        paragraph.innerHTML += '<span class="icon"><a href="https://gitlab.com/'+ gitlab.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      if(github.checkValidity() && github.value.length>0)
      {
        //source = checked ? github_svg : './res/github.svg';
        source = checked ? './res/github.png' : './res/github.svg';
        paragraph.innerHTML += '<span class="icon"><a href="https://github.com/'+ github.value +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      if(location.checkValidity() && location.value.length>0)
      {
        //source = checked ? location_svg : './res/location.svg';
        source = checked ? './res/location.png' : './res/location.svg';
        paragraph.innerHTML += '<span class="icon"><a href="https://www.google.com/maps/dir/Your location/'+ encodeURIComponent(location.value) +'" target="_blank"><img src="' + source + '" class="img"></a></span>&nbsp;&nbsp;';
      }
      target.appendChild(paragraph);
    }
    function updateBadge(el)
    { // fetches linkedin badge and renders into a div.
      var badge = document.getElementById("in-badge");
      var division = document.createElement("div");
      var anchor = document.createElement("a");
      var script = document.createElement("script");
      script.type = "text/javascript"; script.src="https://platform.linkedin.com/badges/js/profile.js";
      script.async = true; script.defer = true;
      division.setAttribute("class", "LI-profile-badge"); division.setAttribute("data-version", "v1"); 
      division.setAttribute("data-size", "medium"); division.setAttribute("data-locale", "en_US");
      division.setAttribute("data-type", "vertical"); division.setAttribute("data-theme", "dark");
      division.setAttribute("data-vanity", el.value); 
      anchor.setAttribute("class", "LI-simple-link");
      anchor.setAttribute("href", "https://in.linkedin.com/in/" + el.value +"?trk=profile-badge");
      anchor.innerHTML = "";
      division.appendChild(anchor);
      badge.innerHTML=""; badge.appendChild(division); badge.appendChild(script);
      updateSignature();
    }
    document.onkeyup = function(e) {
      if(e.altKey && (e.which==72 || e.which==104)) {
        e.preventDefault();
        document.querySelector('#help-id').click();
      }
      else if(e.altKey && (e.which==83 || e.which==115)) {
        e.preventDefault();
        document.querySelector('#source-id').click();
      }
      else if(e.altKey && (e.which==67 || e.which==99)) {
        e.preventDefault();
        document.querySelector('#signature-button-id').click();
      }
    }
  </script>
  <style type="text/css">
    .column {
      display: inline-block;
      float: left;
      margin-right: 20px; 
      vertical-align: top;
    }
    .copy {
      border: 1px solid gray;
      border-radius: 5px;
    }
    .signature-header {
      padding-left: 5px;
      color: #005BA1;
      font-size: 12px;
    }
    .signature-sub-header {
      padding-left: 5px;
      color: #005BA1;
      font-size: 10px;
    }
    .icon {
      padding: 5px;
      width: calc(var(--icon-size) + 10px); 
      height: calc(var(--icon-size) + 10px); 
      display: inline-block; 
      cursor: pointer;
    }
    .img {
      width: 100%;
      height: auto;
      margin: auto;
    }    
  </style>
</body>
</html>